//+------------------------------------------------------------------
//|                                                         bb ea.mq5 
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#include <Trade\Trade.mqh>

//--- input parameters
input int                  bands_period     = 20;                 // period of moving average
input int                  bands_period2    = 40;                 // period of moving average
input int                  bands_shift      = 0;                  // shift
input double               deviation        = 2.0;                // number of standard deviations 
input ENUM_APPLIED_PRICE   applied_price    = PRICE_CLOSE;        // type of price
input ENUM_TIMEFRAMES      period           = PERIOD_CURRENT;     // timeframe
input double               Lots             = 0.1;                // Lots to trade (if fixed lots size used)
input double               Risk             = 0;                  // Rsik % (if variable lots size used)
input double               StopLossPips     = 40;                 // Stop loss in pips 
input double               RiskRewardRatio  = 3.0;                // Risk reward ratio
input int                  StartHour        = 5;                  // Start trading after (hour)
input int                  EndingHour       = 15;                 // End trading before (hour)
input int                  maxspread        = 10;                 // max spread

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
double   _point;
int OnInit()
{
   _point   = _Point*MathPow(10,_Digits%2);
   return(0);
}
void OnDeinit(const int reason)
{
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing   0
#define _doOpenBuy   1
#define _doOpenSell  2
#define _doCloseBuy  3
#define _doCloseSell 4



//partenza -1 short 0 long 1

int getLastOrderType(string forSymbol)
{
   if (HistorySelect(0,TimeCurrent()))
   {        
      int  totalPastOrders = HistoryOrdersTotal();
      uint lastOrderType   = -1;
      while(totalPastOrders>0 && !IsStopped())
      {
         ulong ticket = HistoryOrderGetTicket(totalPastOrders-1);
           if (ticket > 0 && (string)HistoryOrderGetString(ticket,ORDER_SYMBOL)==forSymbol) 
           {
               lastOrderType = (uint)HistoryOrderGetInteger(ticket,ORDER_TYPE); break;
           }
           else totalPastOrders--;
      }
      return((int)lastOrderType);
   }               
   return(-1);
}  


double TotalProfit(int mode)
{
   int total = PositionsTotal();
   double profit = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   string sSymbol=PositionGetSymbol(cnt);
      if(PositionSelect(sSymbol) == true && sSymbol == _Symbol && PositionGetInteger(POSITION_MAGIC)) 
      {
      double open  = PositionGetDouble(POSITION_PRICE_OPEN);
      double close = PositionGetDouble(POSITION_PRICE_CURRENT);
      
         if(mode == 1)
         {
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY ) profit = (close - open)/_point;
         else
         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL) profit = (open - close)/_point;
         }
         else
         profit = PositionGetDouble(POSITION_PROFIT) + PositionGetDouble(POSITION_SWAP) + PositionGetDouble(POSITION_COMMISSION);
      }
   }
    
   return(profit);
}



void OnTick()
{
   if(PositionSelect(_Symbol)) ManageOpened();
   else                        CheckForOpen();
}

//
//
//
//
//
   
   
void ManageOpened()
{
   int doWhat = checkExit(); if (doWhat==_doNothing) return;

   //
   //
   //
   //

                  
      ENUM_ORDER_TYPE signal2;
      if (doWhat==_doCloseBuy)  signal2 = ORDER_TYPE_SELL;
      if (doWhat==_doCloseSell) signal2 = ORDER_TYPE_BUY;
      
      if (TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
      {
         double bp2;
            if (doWhat==_doCloseSell)
            {
               bp2 = (double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);
               
            }
            if (doWhat==_doCloseBuy)
            {
               bp2 = (double)SymbolInfoDouble(_Symbol,SYMBOL_BID);
               
            }
      
            //
            //
            //
            //
            //
         
         CTrade trade;
                //trade.PositionOpen(_Symbol,signal,getLots(Lots,Risk,StopLossPips*pip),SymbolInfoDouble(_Symbol,signal==ORDER_TYPE_SELL ? SYMBOL_BID:SYMBOL_ASK),sl,tp);
               trade.PositionClose(_Symbol);
      }   
   
   
   
}

void CheckForOpen()
{
   int doWhat = checkEntry(); if (doWhat==_doNothing) return;

   //
   //
   //
   //
   //
   
      int    digits = (int)SymbolInfoInteger(_Symbol,SYMBOL_DIGITS);
      double point  = (double)SymbolInfoDouble(_Symbol,SYMBOL_POINT);
      double pip    = point; if (digits==3 || digits==5) pip = point*10.0;

      //
      //
      //
      //
      //
            
                  
      ENUM_ORDER_TYPE signal=-1;
      if (doWhat==_doOpenBuy)  signal = ORDER_TYPE_BUY;
      if (doWhat==_doOpenSell) signal = ORDER_TYPE_SELL;
      
      if (TerminalInfoInteger(TERMINAL_TRADE_ALLOWED))
      {
         double sl,tp,bp;
            if (doWhat==_doOpenBuy)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);
               sl = bp-StopLossPips*pip;
               tp = bp+StopLossPips*pip*RiskRewardRatio;
            }
            if (doWhat==_doOpenSell)
            {
               bp = (double)SymbolInfoDouble(_Symbol,SYMBOL_BID);
               sl = bp+StopLossPips*pip;
               tp = bp-StopLossPips*pip*RiskRewardRatio;
            }
      
            //
            //
            //
            //
            //
         
         CTrade trade;
                trade.PositionOpen(_Symbol,signal,getLots(Lots,Risk,StopLossPips*pip),SymbolInfoDouble(_Symbol,signal==ORDER_TYPE_SELL ? SYMBOL_BID:SYMBOL_ASK),sl,tp);
               // trade.PositionClose(_Symbol);
      }
}

   


//
//
//
//
//

int checkEntry()
{
   //--- get current Bid
   double curBidVal=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   //--- get current Spread
   int spread=int(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));

   
   if (PositionSelect(_Symbol)) return(_doNothing);

   //
   //
   //
   //
   //

   MqlDateTime ct; TimeToStruct(TimeCurrent(),ct);
   static int handle_BB = 0;
          if (handle_BB == 0) handle_BB = iBands(_Symbol,period,bands_period,bands_shift,deviation,applied_price);
          if (handle_BB == INVALID_HANDLE) return(_doNothing);
          //
          //
          //
          //
          //
          
          double upenvelope[3],dnenvelope[3];
          bool allowedHours =  (ct.hour>StartHour && ct.hour<EndingHour);
               if (!allowedHours)                                                                   return(_doNothing);
               if (CopyBuffer(handle_BB,0,0,3,upenvelope)!=3)                                       return(_doNothing);
               if (CopyBuffer(handle_BB,1,0,3,dnenvelope)!=3)                                       return(_doNothing);
               if ((curBidVal>=upenvelope[0])&&(spread<=maxspread) && getLastOrderType(_Symbol)!=1) return(_doOpenBuy);
               if ((curBidVal<=dnenvelope[0])&&(spread<=maxspread) && getLastOrderType(_Symbol)!=0) return(_doOpenSell);
                                                                                                    return(_doNothing);
}


int checkExit()
{
   //--- get current Bid
   double curBidVal=SymbolInfoDouble(Symbol(),SYMBOL_BID);
   
   //--- get current Spread
   int spread=int(SymbolInfoInteger(_Symbol,SYMBOL_SPREAD));

   
   if (PositionSelect(_Symbol)) return(_doNothing);

   //
   //
   //
   //
   //

   MqlDateTime ct; TimeToStruct(TimeCurrent(),ct);
   static int handle_BB2 = 0;
          if (handle_BB2 == 0) handle_BB2 = iBands(_Symbol,period,bands_period2,bands_shift,deviation,applied_price);
          if (handle_BB2 == INVALID_HANDLE) return(_doNothing);
          //
          //
          //
          //
          //
          
          double upenvelope2[3],dnenvelope2[3];
          bool allowedHours =  (ct.hour>StartHour && ct.hour<EndingHour);
               if (!allowedHours)                                                                   return(_doNothing);
               if (CopyBuffer(handle_BB2,0,0,3,upenvelope2)!=3)                                     return(_doNothing);
               if (CopyBuffer(handle_BB2,1,0,3,dnenvelope2)!=3)                                     return(_doNothing);
               if ((curBidVal>=upenvelope2[0])&&(spread<=maxspread))                                return(_doCloseSell);
               if ((curBidVal<=dnenvelope2[0])&&(spread<=maxspread))                                return(_doCloseBuy);
                                                                                                    return(_doNothing);
}
//----------------------------------------------------------------------------------------
//                                 
//----------------------------------------------------------------------------------------
//
//
//
//
//
//
//

double getLots(double BaseLot, double risk, double stopLossDistance)
{
   double TickValue = SymbolInfoDouble(_Symbol,SYMBOL_TRADE_TICK_VALUE);
   double MinLots   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN) ,2);
   double MaxLots   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX) ,2);
   double LotStep   = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_STEP),2);
   double lots      = BaseLot;
   int    LotDigit;

      if (LotStep==1)    LotDigit=0;
      if (LotStep==0.1)  LotDigit=1;
      if (LotStep==0.01) LotDigit=2;
      if (risk>0 && stopLossDistance>0)
      {
         if (AccountInfoDouble(ACCOUNT_BALANCE)>AccountInfoDouble(ACCOUNT_FREEMARGIN))
               lots = NormalizeDouble(AccountInfoDouble(ACCOUNT_FREEMARGIN)*(risk/100.0)/(stopLossDistance*TickValue/_Point),LotDigit);
         else  lots = NormalizeDouble(AccountInfoDouble(ACCOUNT_BALANCE)   *(risk/100.0)/(stopLossDistance*TickValue/_Point),LotDigit);
      }      
   return(MathMax(MathMin(lots,MaxLots),MinLots));   
}

